This section summarizes the service handlers supported by the TeraFlowSDN controller.

- [7.1. L2NM Emulated](#71-l2nm-emulated)
- [7.2. L2NM IETF L2VPN](#72-l2nm-ietf-l2vpn)
- [7.3. L2NM NetConf OpenConfig](#73-l2nm-netconf-openconfig)
- [7.4. L2NM P4](#74-l2nm-p4)
- [7.5. L3NM Emulated](#75-l3nm-emulated)
- [7.6. L3NM gNMI OpenConfig](#76-l3nm-gnmi-openconfig)
- [7.7. L3NM NetConf OpenConfig](#77-l3nm-netconf-openconfig)
- [7.8. L3NM IETF ACTN](#78-l3nm-ietf-actn)
- [7.9. End-to-end Orchestrator](#79-end-to-end-orchestrator)
- [7.10. Microwave](#710-microwave)
- [7.11. Optical OpenConfig](#711-optical-openconfig)
- [7.12. Transport API](#712-transport-api)
- [7.13. XR Pluggable](#713-xr-pluggable)


## **7.1. L2NM Emulated**

__Documentation in progress__

Service handler to configure L2 connectivity services using emulated driver.

<h3><u>Suported Drivers:</h3></u>

- Emulated

## **7.2. L2NM IETF L2VPN**

__Documentation in progress__

Service handler to configure L2 VPNs using emulated driver.

<h3><u>Suported Drivers:</h3></u>

- Emulated

## **7.3. L2NM NetConf OpenConfig**

__Documentation in progress__

Service handler to configure L2 VPNs using NetConf/OpenConfig for packet routers/switches.

<h3><u>Suported Drivers:</h3></u>

- Packet Routers/Switches with NetConf OpenConfig

## **7.4. L2NM P4**

__Documentation in progress__

Service handler to configure L2 packet forward in P4 switches.

<h3><u>Suported Drivers:</h3></u>

- P4

## **7.5. L3NM Emulated**

__Documentation in progress__

Service handler to configure L3 connectivity services using emulated driver.

<h3><u>Suported Drivers:</h3></u>

- Emulated

## **7.6. L3NM gNMI OpenConfig**

__Documentation in progress__

Service handler to configure L3 connectivity services using gNMI/OpenConfig for packet routers.

<h3><u>Suported Drivers:</h3></u>

- Packet Routers with gNMI OpenConfig

## **7.7. L3NM NetConf OpenConfig**

__Documentation in progress__

Service handler to configure L3 VPNs using NetConf/OpenConfig for packet routers.

<h3><u>Suported Drivers:</h3></u>

- Packet Routers with NetConf OpenConfig

## **7.8. L3NM IETF ACTN**

__Documentation in progress__

Service handler to configure L3 VPNs on top of optical connections using IETF ACTN.

<h3><u>Suported Drivers:</h3></u>

- IETF ACTN

## **7.9. End-to-end Orchestrator**

__Documentation in progress__

**WARNING**: Experimental service handler to for a parent TeraFlowSDN end-to-end orchestrator to configure child TeraFlowSDN controllers acting as IP & Optical SDN controllers.

<h3><u>Suported Drivers:</h3></u>

- Optical TFS
- IETF L2VPN

## **7.10. Microwave**

__Documentation in progress__

Service handler to configure L2 microwave links.

<h3><u>Suported Drivers:</h3></u>

- Microwave

## **7.11. Optical OpenConfig**

__Documentation in progress__

**WARNING**: Experimental service handler to configure L0 optical connections.

<h3><u>Suported Drivers:</h3></u>

- Optical TFS

## **7.12. Transport API**

__Documentation in progress__

Service handler to configure L0 optical connections through intermediate TAPI controller.

<h3><u>Suported Drivers:</h3></u>

- Transport API

## **7.13. XR Pluggable**

Service handler to configure XR pluggables for L0 optical connections through intermediate Infinera IPM controller.

<h3><u>Suported Drivers:</h3></u>

- Infinera IPM XR